/*************************************************************/
/*Written by Richard Jones
/*Released under the GPL license
/* The indentation is set for tab space = 2
/*************************************************************/
#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/types.h>
#include <pwd.h>
#include <sys/stat.h>
#include "anonyboth.h"

/*define position of data in the cTree*/
#define SHOW_POS 3
#define TITLE_POS 2
#define THREAD_POS 1
#define FILENAME_POS 0

/*global data (yuk!)*/
/*set this way so the calllback functions can grab the data from them*/
/*************************/
/*Main window pointers*/
GtkWidget *window;
GtkWidget *table;
GtkWidget *serverLabel;
GtkWidget *srvIPEntry;
GtkWidget *newButton, *replyButton, *getHeadersButton;
GtkWidget *vpane;
GtkWidget *leftScroll;
GtkWidget *textView;
GtkWidget *scrollbar;
GtkWidget *hBox;
GtkWidget *myCTree;
/*********************************************/
/*Message writing window pointers*/
GtkWidget *message;
GtkWidget *messageSEND;
GtkWidget *messageCANCEL;
GtkWidget *messageHead;
GtkWidget *messageText;
GtkWidget *messageLabel1;
GtkWidget *messageLabel2;
GtkWidget *messageTable;
/*data used by more than one subroutine*/
gchar currentFileName[FILE_SIZE];
gchar currentThread[FILE_SIZE];
gchar currentTitle[TITLE_SIZE];
gchar sendingThread[FILE_SIZE];
gchar sendingParent[FILE_SIZE];
/*used for storing data to the disk*/
struct passwd *user;
char *homeFiles;

/******************************************************/
/*Define stuff to be called from further on*/
int ConnectToServer ();
void DisconnectFromServer (int s);

/*Callback functions*/
/*Called to tidy up on ending the program*/
gint
TidyUp (GtkWidget * widget, gpointer data)
{
FILE *tx;
/*Save the current server data in $HOME;/.anonynews*/
	tx=fopen("server","w");
	if(tx!=NULL)
		{
		fputs(gtk_entry_get_text(GTK_ENTRY(srvIPEntry)),tx);
		fclose(tx);
		}
	else
		{
		g_print("Cannot open file $HOME/.anonynews/server\n");
		};
/*finally call the exit routine*/
  gtk_main_quit ();
  return (FALSE);
};

/**********************************************************/
/*Called to send a message*/
void
SendMessage (GtkWidget * widget, gpointer data)
{
  int s;			/*socket name */
  FILE *tx;
  FILE *rx;
  fd_set readSockets;		/*set of sockets to look for data on */
  char buffer[BUFFER_SIZE];
  struct timeval timeOut;
  int z;
  char *zz;
  gchar *theTextMessage;
  int titleLength;

/*do the sending here....*/
  s = ConnectToServer ();
/*create file descriptors to read/write from the socket*/
  tx = fdopen (s, "w");
  rx = fdopen (dup (s), "r");
  if ((tx == NULL) || (rx == NULL))
    {
      g_print ("Child could not link fd to socket\n");
    }
  else
    {				/*can get stuff cos we're connected */
      timeOut.tv_sec = TIME_SECS;
      timeOut.tv_usec = TIME_USECS;	/*set the timeout */
      FD_ZERO (&readSockets);	/*zero the soccket list */
      FD_SET (s, &readSockets);	/*put my socket into the list */
      /*listen for the OK */
      z = select (s + 1, &readSockets, NULL, NULL, &timeOut);	/*wait for timeout */
      if (z > 0)		/*something to read */
	{
	  zz = fgets (buffer, sizeof buffer, rx);
	  if (zz != NULL)	/*connected and read the OK */
	    {
	      /*tell it to read a message */
	      fputs (WRITE_MSG, tx);
	      fflush (tx);
	      z = select (s + 1, &readSockets, NULL, NULL, &timeOut);	/*wait for timeout */
	      if (z > 0)	/*something to read */
		{
		  zz = fgets (buffer, sizeof buffer, rx);
		  if (zz != NULL)	/*receive OK-can send the title */
		    {
		    /*getting text from the entry adds a line feed so get rid of it*/
		    titleLength=strlen(gtk_entry_get_text(GTK_ENTRY(messageHead)));
		    if(titleLength>TITLE_SIZE-1)
		    	{
		    	titleLength=TITLE_SIZE-1;
		    	}
		  /*  else
		    	{
		    	titleLength--;
		    	}*//*removed to see if this stops the wrong title length*/
		    strncpy(buffer,gtk_entry_get_text(GTK_ENTRY(messageHead)),titleLength);
		    buffer[titleLength]='\0';
				fputs(buffer,tx);
		  	fputs("\n",tx);
		      fflush (tx);
		      z = select (s + 1, &readSockets, NULL, NULL, &timeOut);	/*wait for timeout */
		      if (z > 0)	/*something to read */
			{
			  zz = fgets (buffer, sizeof buffer, rx);
			  if (zz != 0)	/*ready to send thread */
			    {
			      fputs (sendingThread, tx);
			      fputs ("\n", tx);
			      fflush (tx);
			      z = select (s + 1, &readSockets, NULL, NULL, &timeOut);	/*wait for timeout */
			      if (z > 0)	/*something to read */
				{
				  zz = fgets (buffer, sizeof buffer, rx);
				  if (zz != 0)	/*ready to send parent */
				    {
				      fputs (sendingParent, tx);
				      fputs ("\n", tx);
				      fflush (tx);
				      z =
					select (s + 1, &readSockets, NULL, NULL, &timeOut);	/*wait for timeout */
				      if (z > 0)	/*something to read */
					{
					  fgets (buffer, sizeof buffer, rx);
					  if (zz != 0)	/*ready to send text of message */
					    {
					      theTextMessage =
						gtk_editable_get_chars
						(GTK_EDITABLE (messageText),
						 0, -1);
					      fputs (theTextMessage, tx);
					      fflush (tx);
					      g_free (theTextMessage);
					    }
					}
				    }
				}

			    }
			}
		    }
		}
	    }
	}
    };

  /*now shut down the sockets */
  fclose (tx);
  fclose (rx);
  DisconnectFromServer (s);
/*now hide the widgets*/
  gtk_widget_hide (message);
  gtk_widget_hide (messageSEND);
  gtk_widget_hide (messageCANCEL);
  gtk_widget_hide (messageHead);
  gtk_widget_hide (messageText);
  gtk_widget_hide (messageLabel1);
  gtk_widget_hide (messageLabel2);
  gtk_widget_hide (messageTable);
};

/**************************************/
/*Called to CANCEL sending a message*/
void
CancelMessage (GtkWidget * widget, gpointer data)
{
  gtk_widget_hide (message);
  gtk_widget_hide (messageSEND);
  gtk_widget_hide (messageCANCEL);
  gtk_widget_hide (messageHead);
  gtk_widget_hide (messageText);
  gtk_widget_hide (messageLabel1);
  gtk_widget_hide (messageLabel2);
  gtk_widget_hide (messageTable);
};

/***************************************************/
/*the call back function for the selection of a node*/
void
SomethingSelected (GtkCTree * theTree,
		   GtkCTreeNode * node, gint column, gpointer data)
{
  gchar **theText;
  int s;			/*socket name */
  FILE *tx;
  FILE *rx;
  fd_set readSockets;		/*set of sockets to look for data on */
  char buffer[BUFFER_SIZE];
  struct timeval timeOut;
  int z;
  char *zz;
  int charCount;
/*remove all text from the text widget*/
  charCount = gtk_text_get_length (GTK_TEXT (textView));
  gtk_text_set_point (GTK_TEXT (textView), 0);	/*insertion point = first char */
  gtk_text_forward_delete (GTK_TEXT (textView), charCount);
/*put the filename into the global variable ready for a reply*/
  gtk_ctree_node_get_text (theTree, node, FILENAME_POS, theText);
  strncpy (currentFileName, *theText, FILE_SIZE - 1);
  currentFileName[FILE_SIZE - 1] = '\0';	/*make sure the end point is set to NULL */
/*put the thread into the global variable ready for a reply*/
  gtk_ctree_node_get_text (theTree, node, THREAD_POS, theText);
  strncpy (currentThread, *theText, FILE_SIZE - 1);
  currentThread[FILE_SIZE - 1] = '\0';	/*make sure the end point is set to NULL */
/*put the title into the global variable ready for a reply*/
  gtk_ctree_node_get_text (theTree, node, TITLE_POS, theText);
  strncpy (currentTitle, *theText, TITLE_SIZE - 1);
  currentTitle[TITLE_SIZE - 1] = '\0';	/*make sure the end point is set to NULL */
/*if the current file is "x" then we are on a thread holder, not a message*/
/*so just give a message saying so*/
  if (strncmp (currentFileName, "x", 1) == 0)
    {
      gtk_text_insert (GTK_TEXT (textView), NULL,
		       NULL, NULL,
		       "This is a thread holder, not a message.\n", -1);
      gtk_text_insert (GTK_TEXT (textView), NULL,
		       NULL, NULL, "Please choose a message to read.\n", -1);
      /*expand the tree at this point */
      gtk_ctree_expand_recursive (theTree, node);
      /*hide the reply button */
      gtk_widget_hide (replyButton);
    }
  else
    {
      /*show the reply button */
      gtk_widget_show (replyButton);
/**now connect and get the message*/
      s = ConnectToServer ();
/*create file descriptors to read/write from the socket*/
      tx = fdopen (s, "w");
      rx = fdopen (dup (s), "r");
      if ((tx == NULL) || (rx == NULL))
	{
	  g_print ("Child could not link fd to socket\n");
	}
      else
	{			/*can get stuff cos we're connected */
	  timeOut.tv_sec = TIME_SECS;
	  timeOut.tv_usec = TIME_USECS;	/*set the timeout */
	  FD_ZERO (&readSockets);	/*zero the soccket list */
	  FD_SET (s, &readSockets);	/*put my socket into the list */
	  /*listen for the OK */
	  z = select (s + 1, &readSockets, NULL, NULL, &timeOut);	/*wait for timeout */
	  if (z > 0)		/*something to read */
	    {
	      zz = fgets (buffer, sizeof buffer, rx);
	      if (zz != NULL)
		{
		  /*tell it to send us a message */
		  fputs (READ_MSG, tx);
		  fflush (tx);
		  /*listen for the OK */
		  z = select (s + 1, &readSockets, NULL, NULL, &timeOut);	/*wait for timeout */
		  if (z > 0)	/*something to read */
		    {
		      zz = fgets (buffer, sizeof buffer, rx);
		      if (zz != NULL)
			{
			  /*tell it the filename we want */
			  fputs (currentFileName, tx);
			  fputc ('\n', tx);
			  fflush (tx);
			  /*read the title from the server */
			  z = select (s + 1, &readSockets, NULL, NULL, &timeOut);	/*wait for timeout */
			  if (z > 0)	/*something to read */
			    {
			      zz = fgets (buffer, sizeof buffer, rx);
			      /*send an OK */
			      fputs ("OK\n", tx);
			      fflush (tx);
			      /*wait for the message data */
			      z = select (s + 1, &readSockets, NULL, NULL, &timeOut);	/*wait for timeout */
			      if (z > 0)	/*something to read */
				{
				  z = fgetc (rx);
				  charCount = 0;
				  while ((z != EOF) && (charCount < MAX_MESSAGE_SIZE))	/*read one char at a time */
				    /*this is to allow paragraphs to look good in auto sizing windows */
				    {
				      gtk_text_insert (GTK_TEXT (textView),
						       NULL, NULL, NULL,
						       (char *) &z, 1);	/*put the chars into the text widget */
				      z = fgetc (rx);
				      charCount++;
				    };
				}
			      else
				{
				  gtk_text_insert (GTK_TEXT (textView), NULL,
						   NULL, NULL,
						   "Timeout on retrieval.\nEither:\n",
						   -1);
				  gtk_text_insert (GTK_TEXT (textView), NULL,
						   NULL, NULL,
						   "Server is busy\nMessage has been deleted\nLink has dropped\n",
						   -1);};
			    }
			};
		    };
		};
	    };
	}
      fclose (tx);
      fclose (rx);
      DisconnectFromServer (s);
    };
}

/**********************************************************/
/*callback fuction for writing a message*/
void
MakeMessage (GtkWidget * widget, gpointer data)
{
  int charCount;
/*if data is NULL then it is a new message. If not, it is a reply to the highlighted one*/
/*set the thread & parent in case a new message is read before sending*/
  if (data != NULL)
    {
      strncpy (sendingThread, currentThread, FILE_SIZE-1);
      strncpy (sendingParent, currentFileName, FILE_SIZE-1);
      /*Just in case it fills the thing up...*/
      sendingThread[FILE_SIZE-1]='\0';
      sendingParent[FILE_SIZE-1]='\0';
    }
  else
    {
      strcpy (sendingThread, "0");
      strcpy (sendingParent, "0");
    }
  /*remove all text from the text widget */
  charCount = gtk_text_get_length (GTK_TEXT (messageText));
  gtk_text_set_point (GTK_TEXT (messageText), 0);	/*insertion point = first char */
  gtk_text_forward_delete (GTK_TEXT (messageText), charCount);
/*blank out the header*/
  gtk_entry_set_text (GTK_ENTRY (messageHead), "");
/*if it's a reply, copy in the current header with a RE: if required*/
  if (data != NULL)
    {
      gtk_entry_set_text (GTK_ENTRY (messageHead), currentTitle);
      if (strncmp (currentTitle, "RE: ", 4) != 0)
	{
	  gtk_entry_prepend_text (GTK_ENTRY (messageHead), "RE: ");
	};
    };
  /*show the message creation window widgets */
  gtk_widget_show (message);
  gtk_widget_show (messageSEND);
  gtk_widget_show (messageCANCEL);
  gtk_widget_show (messageHead);
  gtk_widget_show (messageText);
  gtk_widget_show (messageLabel1);
  gtk_widget_show (messageLabel2);
  gtk_widget_show (messageTable);
};

/*******************************************************/
/*callback function for Get Headers button*/
/*Each node in the tree has four bits of data-the title, a copy of the title, the filename and the thread name*/
/*Each thread starts with a thread holder to keep together replies to a message that has been deleted*/
void
GetHeaders (GtkWidget * widget, gpointer data)
{
  int s;			/*socket name */
  FILE *tx;
  FILE *rx;
  fd_set readSockets;		/*set of sockets to look for data on */
  char buffer[BUFFER_SIZE];
  struct timeval timeOut;
  int z;
  char *zz;
  int m, i;
  gchar *myText[FILE_SIZE], title[TITLE_SIZE],
    name[FILE_SIZE], parent[FILE_SIZE], thread[FILE_SIZE];
  gchar **theText;
  GtkCTreeNode *threadNode;
  GtkCTreeNode *myNode;
  /*hide the button so it can't be pressed again. This is due to it crashing if the tree is expanded... */
  /*FIX THIS later */
  gtk_widget_hide (getHeadersButton);
  s = ConnectToServer ();
/*create file descriptors to read/write from the socket*/
  tx = fdopen (s, "w");
  rx = fdopen (dup (s), "r");
  if ((tx == NULL) || (rx == NULL))
    {
      g_print ("Child could not link fd to socket\n");
    }
  else
    {				/*can get stuff cos we're connected */
      timeOut.tv_sec = TIME_SECS;
      timeOut.tv_usec = TIME_USECS;	/*set the timeout */
      FD_ZERO (&readSockets);	/*zero the soccket list */
      FD_SET (s, &readSockets);	/*put my socket into the list */
      /*listen for the OK */
      z = select (s + 1, &readSockets, NULL, NULL, &timeOut);	/*wait for timeout */
      if (z > 0)		/*something to read */
	{
	  zz = fgets (buffer, sizeof buffer, rx);
	  if (zz != NULL)
	    {
	      g_print (buffer);
	    };
	};
      /*tell the server to give us the full list */
      fputs (READ_MSG_HEADERS, tx);
      fflush (tx);
      /*listen for the messages */
      do
	{
	  z = select (s + 1, &readSockets, NULL, NULL, &timeOut);	/*wait for timeout */
	  if (z > 0)		/*something to read */
	    {
	      /*this bit looks to see if we're at eof and if we are, exits the loop */
	      m = getc (rx);
	      if (m != EOF)
		{
		  ungetc (m, rx);
		  zz = fgets (buffer, sizeof buffer, rx);
		  if (zz != NULL)
		    {
		      strncpy (name, buffer, sizeof (name) - 1);
		      name[sizeof (name) - 1] = '\0';
		    };
		  zz = fgets (buffer, sizeof buffer, rx);
		  if (zz != NULL)
		    {
		      strncpy (title, buffer, sizeof (title) - 1);
		      title[sizeof (title) - 1] = '\0';
		    };
		  zz = fgets (buffer, sizeof buffer, rx);
		  if (zz != NULL)
		    {
		      strncpy (thread, buffer, sizeof (thread) - 1);
		      thread[sizeof (thread) - 1] = '\0';
		    };
		  zz = fgets (buffer, sizeof buffer, rx);
		  if (zz != NULL)
		    {
		      strncpy (parent, buffer, sizeof (thread) - 1);
		      parent[sizeof (parent) - 1] = '\0';
		    };
		  /*tell it we got the stuff */
		  fputs ("OK\n", tx);
		  fflush (tx);
		  /*put it into the ctree */
/***************************************************this must be rewritten for speed later on*/
		  *myText = name;
		  i = 0;
		  threadNode = NULL;
		  do
		    {
		      myNode = gtk_ctree_node_nth (GTK_CTREE (myCTree), i++);
		      if (myNode != NULL)
			{
			  /*see if this is the right thread */
			  if (threadNode == NULL)	/*ie we haven't found it yet */
			    {
			      gtk_ctree_node_get_text (GTK_CTREE (myCTree),
						       myNode, THREAD_POS,
						       theText);
			      if (strncmp (thread, *theText, FILE_SIZE - 1) == 0)	/*this is the thread */
				{
				  /*remember the place */
				  threadNode = myNode;
				}
			    }
			  /*now look to see if it is the right parent */
			  gtk_ctree_node_get_text (GTK_CTREE (myCTree),
						   myNode, FILENAME_POS,
						   theText);
			  if (strncmp (parent, *theText, FILE_SIZE - 1) == 0)	/*we have found the parent */
			    {
			      myNode =
				gtk_ctree_insert_node (GTK_CTREE (myCTree),
						       myNode, NULL, myText,
						       2, NULL, NULL, NULL,
						       NULL, FALSE, TRUE);
			      gtk_ctree_node_set_text (GTK_CTREE (myCTree),
						       myNode, TITLE_POS,
						       title);
			      gtk_ctree_node_set_text (GTK_CTREE (myCTree),
						       myNode, SHOW_POS,
						       title);
			      gtk_ctree_node_set_text (GTK_CTREE (myCTree),
						       myNode, THREAD_POS,
						       thread);
			      /*set myNode==NULL to force an exit */
			      myNode = NULL;
			    }
			}
		      else	/*parent not found cos at end */
			{
			  /*if the thread exists, put it into the top level of the thread */
			  if (threadNode != NULL)
			    {
			      *myText = name;
			      myNode =
				gtk_ctree_insert_node (GTK_CTREE (myCTree),
						       threadNode, NULL,
						       myText, 2, NULL, NULL,
						       NULL, NULL, FALSE,
						       TRUE);
			      gtk_ctree_node_set_text (GTK_CTREE (myCTree),
						       myNode, TITLE_POS,
						       title);
			      gtk_ctree_node_set_text (GTK_CTREE (myCTree),
						       myNode, SHOW_POS,
						       title);
			      gtk_ctree_node_set_text (GTK_CTREE (myCTree),
						       myNode, THREAD_POS,
						       thread);
			      /*set myNode==NULL to force an exit */
			      myNode = NULL;
			    }
			  else	/*neither the parent nor the thread exist */
			    {
			      /*create a holder for this thread's messages */
			      *myText = "x";	/*a non-valid filename-first character must not be a number */
			      myNode =
				gtk_ctree_insert_node (GTK_CTREE (myCTree),
						       NULL, NULL, myText, 2,
						       NULL, NULL, NULL, NULL,
						       FALSE, TRUE);
			      gtk_ctree_node_set_text (GTK_CTREE (myCTree),
						       myNode, TITLE_POS,
						       title);
			      gtk_ctree_node_set_text (GTK_CTREE (myCTree),
						       myNode, SHOW_POS,
						       title);
			      gtk_ctree_node_set_text (GTK_CTREE (myCTree),
						       myNode, THREAD_POS,
						       thread);
			      /*put the message against the new holder */
			      *myText = name;
			      myNode =
				gtk_ctree_insert_node (GTK_CTREE (myCTree),
						       myNode, NULL, myText,
						       2, NULL, NULL, NULL,
						       NULL, FALSE, TRUE);
			      gtk_ctree_node_set_text (GTK_CTREE (myCTree),
						       myNode, TITLE_POS,
						       title);
			      gtk_ctree_node_set_text (GTK_CTREE (myCTree),
						       myNode, SHOW_POS,
						       title);
			      gtk_ctree_node_set_text (GTK_CTREE (myCTree),
						       myNode, THREAD_POS,
						       thread);
			      /*set myNode==NULL to force an exit */
			      myNode = NULL;
			    }
			}
		    }
		  while (myNode != NULL);
		};
	    }
	  else
	    {
	      m = EOF;		/*to force a timeout exit */
	      printf ("Timeout waiting for server to respond\n");
	    };
	}
      while (m != EOF);		/*end of do loop */
      /*w collapse the tree completely */
      i = 0;
      do
	{
	  myNode = gtk_ctree_node_nth (GTK_CTREE (myCTree), i++);
	  if (myNode != NULL)
	    {
	      gtk_ctree_collapse_recursive (GTK_CTREE (myCTree), myNode);
	    }
	}
      while (myNode != NULL);
      fclose (tx);
      fclose (rx);
    };
  DisconnectFromServer (s);
};

/*************************************************/
/*Additional Functions*/
/*****************************/
/*Connect to the server*/
int
ConnectToServer ()
{
  int s;			/*for socket */
  int z;
  struct sockaddr_in srvAddress;
/*create a socket*/
  s = socket (AF_INET, SOCK_STREAM, 0);
  if (s < 0)
    {
      g_print ("Failed to create socket\n");
      return -1;
    }
  else
    {
      memset (&srvAddress, 0, sizeof srvAddress);	/*clear the address */
      srvAddress.sin_family = AF_INET;	/*set the family */
      srvAddress.sin_port = htons (PORT_TO_USE);	/*set the port */
      srvAddress.sin_addr.s_addr = inet_addr (gtk_entry_get_text (GTK_ENTRY (srvIPEntry)));	/*set the ip address */
      if (srvAddress.sin_addr.s_addr == INADDR_NONE)
	{
	  g_print ("Bad IP Address\n");
	  return -1;
	}
      else
	{
	  /*try to connect */
	  z = connect (s, (struct sockaddr *) &srvAddress, sizeof srvAddress);
	  if (z == -1)
	    {
	      g_print ("Failed to connect to server\n");
	      return -1;
	    }
	  else
	    {
	      g_print ("Connected to server\n");
	      return s;
	    }
	}
    }
};

/***************************/
/*Disconect from server*/
void
DisconnectFromServer (int s)
{
  g_print ("Disconnected from server\n");
  close (s);
};

/***********************************************/
/*main program**********************************/
int
main (int argc, char **argv)
{
  char extraBit[] = "/.anonynews";
  char serverFromFile[100];/*much too big!*/
  FILE *rx;
  int fileOK=FALSE;

  gtk_init (&argc, &argv);
/*get the user's home directory*/
  user = getpwuid (getuid ());
  if (user != NULL)
    {
      homeFiles =
	malloc ((strlen (user->pw_dir) + strlen (extraBit) + 1) *
		sizeof (char));
      strcpy (homeFiles, user->pw_dir);
      strcat (homeFiles, extraBit);
      if(chdir(homeFiles)<0)
      	{
      	/*anonynews directory does not exist*/
      	if(mkdir(homeFiles,S_IRWXU)<0)
      		{
      		/*failed to make directory*/
      		g_print("Failed to make .anonynews directory\n");
      		}
      	}
      else
      	{
      	/*try to open the file with the saved data in it*/
      	rx=fopen("server","r");
      	if(rx!=NULL)
      		{
      		/*read the data into a variable*/
      		if(fgets(serverFromFile,sizeof serverFromFile,rx)!=NULL)
      			{
	      		fileOK=TRUE;
      			}
      		}
      	};
    }
/*set the current data to non-valid data*/
  memcpy (currentFileName, "x", FILE_SIZE - 1);
  currentFileName[FILE_SIZE - 1] = '\0';
  memcpy (currentThread, "x", FILE_SIZE - 1);
  currentThread[FILE_SIZE - 1] = '\0';
  memcpy (currentTitle, "x", TITLE_SIZE - 1);
  currentTitle[TITLE_SIZE - 1] = '\0';
/*create and show the window*/
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window), "AnonyNews");
  gtk_signal_connect (GTK_OBJECT (window),
		      "destroy", GTK_SIGNAL_FUNC (gtk_main_quit), NULL);
  gtk_container_set_border_width (GTK_CONTAINER (window), 10);
  gtk_widget_set_usize (GTK_WIDGET (window), 790, 590);
  gtk_widget_show (window);
/*add a table*/
  table = gtk_table_new (20, 20, TRUE);
  gtk_container_add (GTK_CONTAINER (window), table);
  gtk_widget_show (table);
/*Put the Server label in*/
  serverLabel = gtk_label_new ("Server:");
  gtk_table_attach_defaults (GTK_TABLE (table), serverLabel, 15, 17, 1, 2);
  gtk_widget_show (serverLabel);
/*put the server ip entry in*/
  srvIPEntry = gtk_entry_new_with_max_length (16);
  gtk_table_attach_defaults (GTK_TABLE (table), srvIPEntry, 17, 20, 1, 2);
  /*set the text to the file entry if it exists*/
  if (fileOK)
  	{
    gtk_entry_set_text (GTK_ENTRY (srvIPEntry), serverFromFile);
  	}
  else
  	{
	  gtk_entry_set_text (GTK_ENTRY (srvIPEntry), "127.0.0.1");
  	};
  gtk_widget_show (srvIPEntry);
/*put the New Message button in*/
  newButton = gtk_button_new_with_label ("New");
  gtk_table_attach_defaults (GTK_TABLE (table), newButton, 1, 2, 1, 2);
  gtk_widget_show (newButton);
/*put the Reply button in*/
  replyButton = gtk_button_new_with_label ("Reply");
  gtk_table_attach_defaults (GTK_TABLE (table), replyButton, 3, 4, 1, 2);
/*	gtk_widget_show (replyButton);*/
/*put the Get Headers Button in*/
  getHeadersButton = gtk_button_new_with_label ("Get Headers");
  gtk_table_attach_defaults (GTK_TABLE (table), getHeadersButton, 5, 8, 1, 2);
  gtk_widget_show (getHeadersButton);
/*add a split pane and add a scrolled window  and an hbox with a text and scrollbar to it*/
  vpane = gtk_hpaned_new ();
  gtk_paned_set_handle_size (GTK_PANED (vpane), 50);
  gtk_paned_set_position (GTK_PANED (vpane), 300);
  gtk_table_attach_defaults (GTK_TABLE (table), vpane, 0, 20, 3, 20);
  leftScroll = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy
    (GTK_SCROLLED_WINDOW (leftScroll),
     GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
/*create a ctree*/
  myCTree = gtk_ctree_new (4, 3);
/*put it into the scroll window*/
  gtk_scrolled_window_add_with_viewport
    (GTK_SCROLLED_WINDOW (leftScroll), myCTree);
  gtk_paned_add1 (GTK_PANED (vpane), leftScroll);
  gtk_widget_show (leftScroll);
  gtk_widget_show (myCTree);
/*add a text box with scrollbar to an hbox*/
  textView = gtk_text_new (NULL, NULL);
  gtk_text_set_editable (GTK_TEXT (textView), FALSE);
  gtk_text_set_word_wrap(GTK_TEXT(textView),TRUE);
/*add a scroll bar*/
  scrollbar = gtk_vscrollbar_new (GTK_TEXT (textView)->vadj);
/*put them both into an hbox*/
  hBox = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hBox), textView, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (hBox), scrollbar, FALSE, FALSE, 0);
/*put the hbox into the right pane*/
  gtk_paned_add2 (GTK_PANED (vpane), hBox);
  gtk_widget_show (scrollbar);
  gtk_widget_show (hBox);
  gtk_widget_show (textView);
  gtk_widget_show (vpane);
/*widgets for creating a message*/
/*nb these are shown only when certain actions are taken*/
  message = gtk_dialog_new ();
  gtk_widget_set_usize (GTK_WIDGET (message), 600, 500);
  gtk_window_set_title (GTK_WINDOW (message), "AnonyNews Message Creator");
  gtk_container_set_border_width (GTK_CONTAINER (message), 10);
/*create the buttons*/
  messageSEND = gtk_button_new_with_label ("Send");
  messageCANCEL = gtk_button_new_with_label ("Cancel");
/*create the header box*/
  messageHead = gtk_entry_new_with_max_length (TITLE_SIZE - 1);
/*create the text box*/
  messageText = gtk_text_new (NULL, NULL);
  gtk_text_set_editable (GTK_TEXT (messageText), TRUE);
  gtk_text_set_word_wrap(GTK_TEXT(messageText),TRUE);
/*create the labels*/
  messageLabel1 = gtk_label_new ("Message Title:");
  messageLabel2 = gtk_label_new ("Message:");
/*create the table and put it into the box*/
  messageTable = gtk_table_new (20, 10, TRUE);
  gtk_box_pack_start (GTK_BOX
		      (GTK_DIALOG
		       (message)->vbox), messageTable, TRUE, TRUE, 0);
/*put things into the table*/
  gtk_table_attach_defaults (GTK_TABLE
			     (messageTable), messageLabel1, 0, 2, 0, 1);
  gtk_table_attach_defaults (GTK_TABLE
			     (messageTable), messageHead, 0, 10, 1, 2);
  gtk_table_attach_defaults (GTK_TABLE
			     (messageTable), messageLabel2, 0, 2, 2, 3);
  gtk_table_attach_defaults (GTK_TABLE
			     (messageTable), messageText, 0, 10, 3, 20);
/*put them into the boxes*/
  gtk_box_pack_start (GTK_BOX
		      (GTK_DIALOG
		       (message)->action_area),
		      messageCANCEL, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX
		      (GTK_DIALOG
		       (message)->action_area), messageSEND, TRUE, FALSE, 0);
/*Attach the controls to the right subroutines*/
  gtk_signal_connect (GTK_OBJECT (message),
		      "delete_event", GTK_SIGNAL_FUNC (CancelMessage), NULL);
  gtk_signal_connect (GTK_OBJECT (window),
		      "delete_event", GTK_SIGNAL_FUNC (TidyUp), NULL);
  gtk_signal_connect (GTK_OBJECT (newButton),
		      "clicked", GTK_SIGNAL_FUNC (MakeMessage), NULL);
  gtk_signal_connect (GTK_OBJECT (replyButton),
		      "clicked",
		      GTK_SIGNAL_FUNC (MakeMessage), currentFileName);
  gtk_signal_connect (GTK_OBJECT
		      (getHeadersButton),
		      "clicked", GTK_SIGNAL_FUNC (GetHeaders), NULL);
  gtk_signal_connect (GTK_OBJECT (myCTree),
		      "tree-select-row",
		      GTK_SIGNAL_FUNC (SomethingSelected), NULL);
  gtk_signal_connect (GTK_OBJECT (messageSEND),
		      "clicked", GTK_SIGNAL_FUNC (SendMessage), NULL);
  gtk_signal_connect (GTK_OBJECT (messageCANCEL),
		      "clicked", GTK_SIGNAL_FUNC (CancelMessage), NULL);
/*start the gtk bit running*/
  gtk_main ();
/*free the memory allocated on the fly*/
  free (homeFiles);

  return 0;
}
